# Generated by Django 5.1.2 on 2024-10-25 20:46

from django.db import migrations


def fill_default_position_ops_groups(apps, schema_editor):
    PositionOpsGroup = apps.get_model("seawatch_registration", "PositionOpsGroup")
    Position = apps.get_model("seawatch_registration", "Position")
    # group_titles = ["Bridge", "Engine Room", "Deck", "Medical"]
    for group_order, (group_title, position_keys) in enumerate(
        [
            (
                "Bridge",
                [
                    "master",
                    "skipper-aurora",
                    "1st-officer",
                    "2nd-officer",
                ],
            ),
            (
                "Engine Room",
                [
                    "chief-eng",
                    "2nd-3rd-eng",
                    "2nd-eng",
                    "3rd-eng",
                    "mechanic-aurora",
                    "engine-rating",
                    "engine-rating-watchkeeping",
                    "engine-support",
                    "ship-elec-it",
                ],
            ),
            (
                "Deck",
                [
                    "bosun",
                    "ab-seaman",
                    "deck-aurora",
                    "deck-rating-watchkeeping",
                    "deck-rating",
                    "deckhand",
                ],
            ),
            (
                "Mission",
                [
                    "hom",
                    "rhib-team-lead",
                    "rhib-driver",
                    "guest-coord",
                    "Guestcare-Coordinator-Trainee",
                    "cult-coord",
                    "protection-officer",
                ],
            ),
            (
                "Hospital",
                [
                    "medic",
                    "physician",
                    "nurse",
                    "paramedic",
                ],
            ),
            (
                "Kitchen",
                [
                    "cook",
                ],
            ),
            (
                "Media",
                [
                    "media-coord",
                ],
            ),
        ]
    ):
        group = PositionOpsGroup.objects.create(title=group_title, order=group_order)
        for order_in_group, position_key in enumerate(position_keys):
            Position.objects.filter(key=position_key).update(
                ops_group=group, ops_group_order=order_in_group
            )


class Migration(migrations.Migration):
    dependencies = [
        (
            "seawatch_registration",
            "0043_positionopsgroup_position_ops_group_order_and_more",
        ),
    ]

    operations = [
        migrations.RunPython(fill_default_position_ops_groups, lambda *a: None),
    ]
